; FREAXx.S - Alien shootem-up game. (C) A.Millett 2014. Released under GPL2
;----------------------------------------------------------------------------
; FREAX is a simple Alien shootem-up game that compiles for the VIC20, C64 & C16/+4.
;  To compile under CA65 set the USE_CA65 flag.
;----------------------------------------------------------------------------
; MODLOG 
;  Simple init chrset, show alien chr.
;-> FREAX1.S (5.7.14)
;  Imp 4-phase 12 bit wide alien chr.
;  Imp NewGame to init AlienLo/AlienHi/AlienType[MAXALIEN] arrays.
;  Imp DrawScreen fn to draw..
;-> FREAX2.S (7.7.14)
;  Imp simple anim
;-> FREAX3.S (8.7.14)
;  Change to using AlienX/Y co-oords in 1/4 chrs (ie: [0-159,0-24] on 40x25 VDU)
;  Simpler anim calcs, bound checks etc.
;  Simple anim working approx as previously.
;-> FREAX4.S (10.7.14)
;  Imp rowend,dropdown - for end of row alien drop down & reverse dir.
;  Works ok, aliens travel across/down in desired way.
;-> FREAX5.S (11.7.14)
;  Imp BaseMove, BaseDraw - Move/Draw player base
;  Imp KeyHit for player base control
;-> FREAX6.S (11.7.14)
;  Start Imp MissileFire, MissileMove..
;  Imp v crude removal of aliens on hit, Level over detect..
;-> FREAX7.S (12.7.14)
;  Imp BombDrop, BombMove - Alien bomb drop & animate..
;-> FREAX8.S (13.7.14)
;  Tidy odd bits (Copy 64 chrs, Use SHIFT for fire, etc..)
;  Imp AlienHit/AlienDelete - detect/find alien hit, ripple delete from array
;-> FREAX9.S (14.7.14)
;  2do - Levels, Missile align, score, titlesc, alien bmp correct, Alt dirs, bonus pills. Fast slow bombs/aliens, double bullets..
;  Imp Title screen. Imp score,hiscore. Imp levels.
;  Tidy up more code. Imp ALIENGAPX - 9 pos gap helps animation.
;-> FREAX10.S (14.7.14)
;  Imp SLOWBOMBS, ALT_DIR..
;-> FREAX11.S (15.7.14)
;-> FREAX12.S (16.7.14)
;   2do: Color. Accurate Collide/Drop. Onscreen Score (hex2dec?). +4/128. Shelters. Better rnd. Difficulty opt. Multi lifes.
;  Imp C16/+4 version. Alter rand function.
;-> FREAX14.S (17.7.14)
;  Imp test for alien reraching bottom
;  Imp numbers
;-> FREAX15.S (18.7.14)
;  Imp end game anim
;  HiScore fix
;-> FREAX16.S (20.7.14)
;  Imp on screen score during play.
;-> FREAX17.S (21.7.14)
;  Imp nlifes - multiple bases
;-> FREAX18.S (21.7.14)
;  Imp +4 score
;-> FREAX19.S (25.7.14)
;  Imp Level display
;-> FREAX20.S (26.7.14)
;  2do: mode (unidir, speed etc), move kill alien to end of scan, imp up/down scan. Ignore alien chr on drop. Missile shave alien - do not erase.
;  Imp Shelter. Imp Exit key.
;-> FREAX21.S (1.8.14)
;  Cont Imp Shelters.
;-> FREAX22.S (2.8.14)
;  Cont shelters..
;-> FREAX23.S (3.8.14)
;  2do: simple color? sound?
;-> FREAX24.S (4.8.14)
;  Imp simple fixed color. (USE_COLOUR)
;-> FREAX25.S (2.4.15)
;  Small fixes..
;-> FREAX27.S (6.3.24)
;--------------------------------------------------------------------------

.define IS_PET 0
.define IS_C64 1
.define IS_V20 0
.define IS_C16 0
.define IS_C128 0

.define DEBUG      0
.define EXTRA      1		; Advanced features
.define SLOWBOMBS  1		; Set if some bombs are slow
.define ALT_DIR    1		; Set for alternating alien direction on each row
.define SHELTERS   1
.define USE_COLOUR 1

.if IS_C64			; CBM 64..
  PRGSTART = $0801
  ZTIME  = $A2		; TIME var
  ZPTEMP = $A3		; Zero page basic temp store (usable by this prg) (4B,A3)
  ZPTR  = $FB
  ZWORK = $FD
  VDUP = $0400		; VDU
  VDUX = 40
  VDUY = 25
  COLORP  = $D800
  COLTOP  = 4
  COLBASE = 1
  COLLOWER = 5
  COLSHELTER = 3
  TapeBuf = $033C
  ChrSet  = $3000
  ZKEYDOWN = $C5	; Key down
  ZKEYSHIFT = $028D	; Shift down
  KEYLEFT  = 33
  KEYRIGHT = 41
  KEYFIRE  = 62
  KEYQUIT  = 23

  VICreg1 = $d011	; VIC Control Register 1 (bit 7= raster bit 8)
  VICmem  = $d018	; VIC Memory Control Register: Bit:4-7 (VDU Base Bit 13-10) Bit:1-3 (Char Set Bit 13-11)
  VICbord = $d020	; VIC border colour
  RPRINTINT = $BDCD        ; PRINT +VE INT (A;X) (C64=BDCD)

.endif

.if IS_V20			; VIC20 (unexpanded)
  PRGSTART = $1001
  ZTIME  = $A2		; TIME var
  ZPTEMP = $A3		; Zero page basic temp store (usable by this prg)
  ZPTR  = $FB
  ZWORK = $FD
  VDUP = $1E00		; VDU
  VDUX = 22
  VDUY = 23
  COLORP = $9600
  COLTOP  = 4
  COLBASE = 1
  COLLOWER = 5
  COLSHELTER = 3
  TapeBuf = $033C
  ChrSet = $1c00
  ZKEYDOWN = $C5	; Key down
  ZKEYSHIFT = $028D	; Shift down
  KEYLEFT  = 12
  KEYRIGHT = 13
  KEYFIRE  = 48
  KEYQUIT  = 26

  VICraster = $9004	; Cur Raster/2
  VICbase = $9005	; Scr/Chr base.
  VICcol = $900f	; Scr/Border colour
  RPRINTINT = $DDCD        ; PRINT +VE INT (A;X) 
.endif

.if IS_C16			; CBM16/+4..
  PRGSTART = $1001
  ZPTEMP = $D0		; Zero page basic temp store (usable by this prg)
  ZPTR  = $FB
  ZWORK = $FD
  VDUP = $0C00		; VDU
  VDUX = 40
  VDUY = 25
  COLORP = $0800
  COLTOP  = 68
  COLBASE = 126
  COLLOWER = 69
  COLSHELTER = 99
  TapeBuf = $0332
  ChrSet  = $2000
  ZKEYDOWN = $07F6	; Key down
  ZKEYSHIFT = $0543	; Shift down

  KEYLEFT  = 33
  KEYRIGHT = 41
  KEYFIRE  = 62
  KEYQUIT  = 23

  TEDmemctl  = $FF12	; Bitmap/Character Memory Control (Bit0-1:Sound MSB, Bit 2:chr/bmp ROM/RAM, Bit3-5:Bmp Base 8K steps)
  TEDchrbase = $FF13	; System Clock and Character Memory Control (Bit 2-7:chr base 1K steps)
  TEDvduloc  = $FF14	; Video ram loc 2k steps (Bit 3-7)
  TEDvducol  = $FF15	; Screen background colour (Bit 0-3:Color, Bit 4-6:Luminance)
  TEDbordcol = $FF19	; Border colour
  TEDrasthi  = $FF1C	; Raster line hi bit (Bit 0)
  TEDraster  = $FF1D	; Current raster line (Bit 0-7)

  RPRINTINT = $A45F	; PRINT +VE INT (A;X) (C64=BDCD)

.endif

  ;RPRINTINT = $8E32        ; C128:PRINT +VE INT (A;X) (C64=BDCD)

KCHROUT = $FFD2		; Write char (A)
KGETIN  = $FFE4		; Read chr (A)

.IF (USE_CA65 = 1)			; Kludge to add start address for .prg files
 .ORG PRGSTART-2
 .WORD PRGSTART
.ELSE
 .ORG PRGSTART
.ENDIF


.if IS_C64		; CBM64 Specific code

  .BYTE $0B,$08,$66,$19,$9E,$32,$30,$36,$31,0,0,0		; BASIC:  6502 SYS2061

InitCode:
   lda #0
   sta VICbord		; Set screen black
   sta VICbord+1
   jsr MainCode

ModeNormal:		; Normal text mode
   lda #$15
   sta VICmem		; Default VDU=$0400,CHRSET=$D000
   rts

ModeGfx:		; Hi-res graphics mode
   lda #$1d
   sta VICmem		; Set VDU=$0400,CHRSET=$3000
   lda #147
   jmp KCHROUT

SyncFly:		; Sync action to screen refresh
  sei 
SyncF1:
  lda VICreg1
  bmi SyncF1
SyncF2:
  lda VICreg1
  bpl SyncF2
  cli
  rts

Int2Asc:		; Convert +ve int (A;X) to Asc @$0100 (see RPRINTINT)
  sta $62
  stx $63
  ldx #$90
  sec
  jsr $bc49
  jmp $bddf

.endif

.if IS_V20		; VIC20 Specific code

  .BYTE $0B,$10,$66,$19,$9E,$34,$31,$30,$39,0,0,0		; BASIC:  6502 SYS4109

InitCode:
   lda #8
   sta VICcol		; Set screen black.
   jsr MainCode

ModeNormal:		; Normal text mode
   lda #$f0
   sta VICbase
   rts

ModeGfx:		; Hi-res graphics mode
   lda #$ff
   sta VICbase
   lda #147
   jmp KCHROUT

SyncFly:		; Sync action to screen refresh
  lda #100
  sei
SyncF1:
  cmp VICraster
  bne SyncF1
  cli
SyncF2:
  ;cmp VICraster
  ;beq SyncF2
  rts

;SyncFly:		; Sync action to screen refresh
;  lda ZTIME
;Sync1:
;  cmp ZTIME
;  beq Sync1
;  rts

Int2Asc:		; Convert +ve int (A;X) to Asc @$0100 (see RPRINTINT)
  sta $62
  stx $63
  ldx #$90
  sec
  jsr $dc49
  jmp $dddf

.endif

.if IS_C16		; C16 Specific code

  .BYTE $0B,$10,$66,$19,$9E,$34,$31,$30,$39,0,0,0		; BASIC:  6502 SYS4109

InitCode:
   lda #0
   sta TEDvducol	; Set screen black
   sta TEDbordcol	; Set screen black
   jsr MainCode

ModeNormal:		; Normal text mode
   lda #208
   sta TEDchrbase
   lda #196
   sta TEDmemctl
   rts

ModeGfx:		; Hi-res graphics mode
   lda #32
   sta TEDchrbase
   lda #192
   sta TEDmemctl
   lda #147
   jmp KCHROUT

SyncFly:		; Sync action to screen refresh
   lda #200
   sei
SyncF1:
   cmp TEDraster
   bne SyncF1
   cli
;RPRINTINT:
   rts

Int2Asc:
  sta $62
  stx $63
  ldx #$90
  sec
  jsr $a2ce
  jmp $a471

.endif

;--------------------------------------------------------------------------
;  Freax - alien specific code
;--------------------------------------------------------------------------

NALIENX = 1+VDUX/3		; #aliens across
NALIENY = 5			; #rows

MAXALIEN = (NALIENX * NALIENY)
MAXBOMBS = 10			; Max# bombs in flight

TOPPOSX = (VDUX*2) - (NALIENX * 4) - (NALIENX/2)	; Start pos for top left alien (1/4 chrs)
TOPPOSY = 2

ALIENGAPX = 9			; X-Gap between aliens
ALIENGAPY = 2			; Y-Gap between rows of aliens

XPOSMIN = 3			; Min/Max positions (reverse at these points)
XPOSMAX = (VDUX*4) - 7

YPOSMASK = 31		; Mask out hit bits alien Y pos (used for dir, etc)

SHELTERWIDTH = 3 + (VDUX/40)
BASESTARTPOS = VDUX*2			; Base start pos in 1/4 chrs
BASEVDU = VDUP + VDUX * (VDUY - 1)	; Base VDU line loc
BASEMAX = (VDUX*4) - 8
NLIFES  = 3			; Default # lifes

CHRSHELTER = 1		; Shelter
CHRALIEN   = 4		; Alien chr start
CHRBASE    = 14		; Player Base chrs..
CHRMISSILE = 23		; Player Missile chrs
CHRBOMB    = 27		; Alien Bomb chrs
CHRNUM     = 33		; Number chrs.. (0..9)
CHRBANG    = 43

ZPUSED    = 32		; #Mem to clr at ZPTEMP
ZPCLRLEV  = 22
ZPNEWGAME = 25

naliens  = ZPTEMP	; no of aliens
calien   = ZPTEMP+1	; Current alien #
palien	 = ZPTEMP+2	; Ptr to cur alien VDU pos.
ycount   = ZPTEMP+4
rvsdir   = ZPTEMP+5	; Bit 7 set if reverse alien dir (left)
rowend   = ZPTEMP+6	; Set when end of row hit
dropdown = ZPTEMP+7	; Set to drop all aliens down 1 row.
alienx   = ZPTEMP+8	; Alien X pos (in 1/4 chrs, ie: 0..159 on 40 col scrn)
alieny   = ZPTEMP+9	; Alien Y pos (ie: 0..24)
basepos  = ZPTEMP+10	; Pos of player base (1/4 chrs)
basedir  = ZPTEMP+11	; Base dir (0,1,$ff)
missilex = ZPTEMP+12	; Missile X pos (1/4 chr)
missiley = ZPTEMP+13	; Missile Y pos
movephase= ZPTEMP+14	; Inc each serv loop, used for timing, etc.
nbombs   = ZPTEMP+15	; # bombs in flight
;bombcount= ZPTEMP+16	; Countdown to next bomb drop
cbomb    = ZPTEMP+17	; Cur bomb
bombpos  = ZPTEMP+18	; Bomb phase temp (0-3)
bomby	 = ZPTEMP+19	; bomb y pos..
basehit	 = ZPTEMP+20	; Set if base hit by bomb/aliens reach end
randseed = ZPTEMP+21	; Rand # seed (2 bytes)
			; 
level    = ZPTEMP+23	; Current level
score    = ZPTEMP+24	; Player Score (2 bytes)
nlifes   = ZPTEMP+26	; # lifes left

	; Assort tables..
tAlienX = TapeBuf				; Table store for alien X/Y loc. (1/4 chr, ie:[0-159,0-24] for 40x25 VDU)
tAlienY = tAlienX + MAXALIEN
tVduPosLo = FreeMem	 		; Start VDU pos for each line
tVduPosHi = FreeMem + VDUY	
tBombX    = FreeMem + VDUY*2		; tBombX/Y[MAXBOMBS] - loc current bombs
tBombY   = tBombX + MAXBOMBS

hiscore:
  .BYTE 0,0

;--------------------------------------------------------------------------
;  Assort general i/o routines
;--------------------------------------------------------------------------

ioRand:			; Simple psuedo-random function, return # in (Acc)
  inc randseed+1
  lda randseed
  asl
  rol
  rol
  adc randseed+1
  tay
  eor ChrData,y
  ;eor ZTIME
  sta randseed
  rts

;--------------------------------------------------------------------------
;  NewGame - Start a new game level
;--------------------------------------------------------------------------

ClrMem:
  ldx #ZPUSED
ClrMemX:
  lda #0		; Clr Zero page vars
  sta ZPTEMP,x
  dex
  bne ClrMemX
  rts

NewGame:
  lda #NLIFES
  sta nlifes
  ldx #ZPNEWGAME
  .byte $2c

NewLevel:
  ldx #ZPCLRLEV
  jsr ClrMemX
  
  .if USE_COLOUR	; Set color for some lines..
    ldx #VDUX*2-1
NewCol:
    lda #COLTOP
    sta COLORP,x
    lda #COLBASE
    sta COLORP-VDUP+BASEVDU-VDUX,x
    lda #COLSHELTER
    sta COLORP-VDUP+BASEVDU-VDUX*5,x
    sta COLORP-VDUP+BASEVDU-VDUX*3,x
    lda #COLLOWER
    sta COLORP-VDUP+BASEVDU-VDUX*9,x
    sta COLORP-VDUP+BASEVDU-VDUX*7,x
    dex
    bpl NewCol
  .endif

  ldx #>VDUP		; Clear VDU
  stx palien+1
  ldx #>(VDUX*VDUY)
  lda #0
  tay 
New2:
  sta (palien),y
  iny
  bne New2
  inc palien+1
  dex
  bpl New2 

  .if SHELTERS
    ldx #0
NewShelter2:
    ldy #SHELTERWIDTH
NewShelter:
    lda #CHRSHELTER
    sta BASEVDU-VDUX*4+VDUX/4-3,x
    sta BASEVDU-VDUX*4+VDUX/2-2,x
    sta BASEVDU-VDUX*4+(3*VDUX)/4,x
    inx
    dey
    bne NewShelter
    txa
    clc
    adc #VDUX-SHELTERWIDTH
    tax
    cpx #VDUX*3
    bcc NewShelter2
  .endif

  lda #MAXALIEN
  sta naliens		; Calc no of aliens
  lda #NALIENY
  sta ycount
  lda #BASESTARTPOS	; Player base start pos
  sta basepos
  ldy #0
  lda #TOPPOSY
  clc 
  adc level
  sta alieny
NewNextY:
  ldx #NALIENX
  lda #TOPPOSX
  sta alienx		; Init Alien top X/Y start pos 
NewNextX:
  lda alienx
  sta tAlienX,y
  clc
  adc # ALIENGAPX
  sta alienx
  lda alieny
  .if ALT_DIR
   and #2		; Alternating rows go alt directions
   lsr
   lsr
   ror
   ora alieny		; Set hi bit on alt rows..
  .endif
  sta tAlienY,y
  iny
  dex
  bne NewNextX
  inc alieny  
  .if (ALIENGAPY > 1)
   inc alieny  
  .endif
  dec ycount
  bne NewNextY


  jsr OutStatus		; Display score

CalcVduPos:		; Calc loopup table with VDU pos start each line (0..VDUY-1)
  lda #<VDUP
  ldy #>VDUP
  ldx #0
CalcLoop:
  sta tVduPosLo,x
  pha
  tya
  sta tVduPosHi,x
  pla
  clc
  adc #VDUX
  bcc Calc1
  iny
Calc1: 
  inx
  cpx #VDUY
  bne CalcLoop
  rts

GetAlienX:		; Read info for current alien (x)
  lda tAlienY,x
  sta alieny
  and #YPOSMASK		; Isolate Y pos bits from other flags
  tay
  lda tAlienX,x
  sta alienx

CalcPosFromXY:		; Calc real VDU loc (palien) from 1/4 chr (x,y) (x = Acc, y = Y reg)
  lsr
  lsr
  clc
  adc tVduPosLo,y
  sta palien		; Calc Real VDU pos from Alien X/Y pos
  lda tVduPosHi,y
  adc #0
  sta palien+1
  rts

SetAlienX:		; Save info for current alien (x)
  lda alienx
  sta tAlienX,x
  lda alieny
  sta tAlienY,x
  rts

;--------------------------------------------------------------------------
;  DrawAlien - Draw alien 
;--------------------------------------------------------------------------

DrawAlien:		; Draw single alien (x)
  jsr GetAlienX
  lda alienx
  and #3		; Calc alien phase 0-3
  asl
  adc #CHRALIEN
DrawAlienAcc:		; Fill alien with chr (a)
  ldy #0
  sta (palien),y
  iny
  adc #1	
  sta (palien),y
  cmp #CHRALIEN+6
  bcc DrawAlienRet
  adc #0	
  iny
  sta (palien),y
DrawAlienRet:
  rts

WipeAlien:
  jsr GetAlienX
  ldy #0
  tya
  sta (palien),y
  iny
  sta (palien),y
  lda alienx
  and #3		; Calc alien phase 0-3
  cmp #3
  bcc WipeAlienRet
  lda #0
  iny
  sta (palien),y
WipeAlienRet:
  rts
  

DrawScreen:		; Draw alien array
  ldx naliens
  dex
Draw1:
  jsr DrawAlien
  dex
  bpl Draw1
  rts

;--------------------------------------------------------------------------
;  AlienNext - move current alien, advance to next on list
;--------------------------------------------------------------------------

AlienNext:		; Animate next alien
  lda naliens
  beq AlienRet
  ldx calien
  cpx naliens
  bcc Alien2

  ldx #0		; End of updating array of aliens, back to top alien.
  stx dropdown
  lda rowend		; Reverse dir?
  beq Alien2
  stx rowend
  lda rvsdir
  eor #$80
  sta rvsdir		; Flip hi bit (rvsdir) 
  dec dropdown		; Drop down all aliens next iteration
Alien2:
  stx calien

  jsr WipeAlien		; Clr old Alien
  lda dropdown		; Drop-down flag set?
  beq AlienMove
  inc alieny		; Move all aliens down 1 row
  lda alieny
  and #YPOSMASK
  cmp #VDUY-2
  bcc AlienRedraw
  dec basehit		; Alien reaches bottom, game over
  bne AlienRedraw

AlienMove:
  lda alieny
  eor rvsdir
  bmi AlienBackDir	; Dir back..
  inc alienx
  lda alienx
  cmp #XPOSMAX		; reached right hand of VDU?
  bcc AlienRedraw
  bcs AlienRvs		; Reverse dir at end of block

AlienBackDir:		; Decrement alien phase/pos
  dec alienx
  lda alienx
  cmp #XPOSMIN
  bcs AlienRedraw

AlienRvs:		; Reverse dir at end of block
  inc rowend

AlienRedraw:
  jsr SetAlienX		; Save updated (x,y) pos for alien (x)
  jsr DrawAlien		; Draw alien in new pos.
  jsr BombDrop
Alien3:
  inc calien		; next alien
AlienRet:
  rts


AlienHit:		; Test for alien hit
  ldx naliens		; Search Alien table for match to (missilex,missiley)
AlienHitNext:
  dex
  bmi AlienNotFound
  lda tAlienY,x
  and #127
  cmp missiley
  bne AlienHitNext	; Vertical pos not matching, next..
  lda missilex
  sec
  sbc tAlienX,x
  cmp #12		; Width of alien in pixels - "hit" area.
  bcc AlienFound	; Alien (x) hit found..
  bcs AlienHitNext
AlienNotFound:
  clc			; Carry clear -> not found
  rts  

AlienFound:		; Alien hit found, 
  jsr WipeAlien		; Clr Alien (x)

AlienDelete:		; Ripple delete Alien (x)
  cpx calien
  bcs AlienDel1
  dec calien		; Adjust (calien) in main wave, to keep animation consistant
AlienDel1:
  inx
  lda tAlienY,x
  dex
  sta tAlienY,x
  inx 
  lda tAlienX,x
  dex
  sta tAlienX,x
  inx
  cpx naliens
  bcc AlienDel1
  dec naliens
  lda level
  lsr
  sec
  adc score		; Increment score by (1+(level/2))
  sta score
  bcc AlienDel2
  inc score+1
AlienDel2:		; Drop through..

OutStatus:		; Update status line
  ldx #CHRALIEN
  stx VDUP+VDUX-7	; Display level alien gfx
  inx
  stx VDUP+VDUX-6
  lda level
  clc
  adc #CHRNUM+1
  sta VDUP+VDUX-5	; Display level
  ldx #CHRBASE
  stx VDUP+VDUX-3	; Display base gfx
  inx
  stx VDUP+VDUX-2
  lda nlifes
  clc
  adc #CHRNUM
  sta VDUP+VDUX-1	; Display no of lifes left
OutScore:		; Update score
  ldx score
  lda score+1
  jsr Int2Asc
  ldx #0
OutS1:
  lda $0100,x
  beq OutS2
  clc 
  adc # (CHRNUM + 256 - 48)  ; Correct to chrset
  sta VDUP,x
  inx
  bne OutS1
OutS2:
  sec			; Carry set if alien found/destroyed
  rts

;--------------------------------------------------------------------------
;  Bomb..  - Bomb drop/move routines
;--------------------------------------------------------------------------

BombDrop:		; Drop bomb from (alienx,alieny)
  jsr ioRand
  lda level
  clc
  adc #3
  cmp randseed
  bcc BombExit
  ldx nbombs
  cpx #MAXBOMBS-1
  bcs BombExit		; Bomb table full
  ldy #VDUX*2
  lda (palien),y	; See if alien 2 lines down, if so skip..
  ldy #1
  sec
  sbc # CHRALIEN
  cmp # (CHRBASE-CHRALIEN)
  bcs BombDr1
  ldy #3		; Is alien chr, skip 3 lines
BombDr1:
  lda alienx
  sta tBombX,x
  tya
  clc
  adc alieny		; Scale y pos..
  asl
  asl
  sta tBombY,x
  inc nbombs
BombExit:
  rts


; Different bomb pos actions..
; pos0: z=peek(+0): poke+0,0:if isterm(z) end: poke +0,b1
; pos1: z=peek(+40):poke+0,0:if isterm(z) end: poke +0,b2:poke +40,b2+1
; pos2: z=peek(+40):poke+0,0:poke+40,0:if isterm(z) end: poke +0,b3:poke +40,b3+1
; pos3: z=peek(+40):poke+0,0:poke+40,0:if isterm(z) end: poke +40,b0

BombPhase:	; Lookup encodes bomb ypos phase (0-3) to drawn chars
  .byte CHRBOMB+1, CHRBOMB+2, CHRBOMB+4, 0
BombPhase2:
  .byte    0	 , CHRBOMB+3, CHRBOMB+5, CHRBOMB

BombMove:		; Move all bombs down 1 position
  ldx #0
BombLoop:
  cpx nbombs
  bcs BombExit
  stx cbomb
  lda tBombY,x
  sta bomby		; temp for later
  lsr
  lsr
  tay
  .if SLOWBOMBS
   lda tBombX,x		; If X pos is odd, its a slow drop bomb
   and #1
   and movephase	; skip on alt cycles
   bne BombNext
  .endif
  lda tBombX,x
  jsr CalcPosFromXY	; Calc VDU pos (palien) from X,Y coords
  ldy #0
  lda bomby
  and #3
  sta bombpos
  beq Bomb1
  ldy #VDUX
Bomb1:
  lda (palien),y	; Save peek of dest hit by bomb
  pha
  ldy #0
  tya
  sta (palien),y	
  lda bombpos
  cmp #2
  bcc Bomb2
  tya
  ldy #VDUX
  sta (palien),y	
Bomb2:
  pla			; retrieve dest hit by bomb
  beq BombDraw		; empty, cont..
  ldy bomby
  cpy #(VDUY*4)-4
  bcs BombEnd
  cmp #CHRMISSILE
  bcs BombDraw
  cmp #CHRBASE
  bcs BombHit

  cmp #CHRSHELTER
  beq Bomb5
  lda #0		; Shelter hit, erase a chr
  .byte $2c
Bomb5:
  lda #CHRSHELTER+1
  ldy #VDUX
  sta (palien),y	
  
BombEnd:		; Ripple-delete cbomb from list
  ldx cbomb
BombEndLoop:
  inx
  lda tBombX,x
  dex
  sta tBombX,x
  inx
  lda tBombY,x
  dex
  sta tBombY,x
  inx
  cpx nbombs
  bcc BombEndLoop
  dec nbombs		; nbombs--;
  bne BombNext
  rts

BombDraw:		; Draw bomb 
  ldx bombpos
  lda BombPhase,x	; Use lookup table to convert bomb y phase (0-3) to chars..
  beq Bomb3
  ldy #0
  sta (palien),y
Bomb3:
  lda BombPhase2,x
  beq Bomb4
  ldy #VDUX
  sta (palien),y
Bomb4:
  ldx cbomb
  inc tBombY,x		; Move bomb down 1/4 chr
BombNext:
  inc cbomb
  ldx cbomb
  jmp BombLoop

BombHit:		; Bomb hits base
  inc basehit
  rts

;--------------------------------------------------------------------------
;  Missile..  - Missile fire/move routines
;--------------------------------------------------------------------------

MissileFire:		; Try to fire player missile
  lda missilex
  bne MissileRet
  ldx basepos
  inx
  inx
  stx missilex
  lda #VDUY-1
  sta missiley
MissileRet:
  rts

MissileMove:		; Move player missile
  lda missilex
  beq MissileRet
  ldy missiley 
  jsr CalcPosFromXY	; Calc VDU loc
  ldy #0
  tya
  sta (palien),y	; Clr old missile
  dec missiley
  beq MissileEnd	; Off screen, kill missile.
  lda missilex
  ldy missiley 
  jsr CalcPosFromXY
  ldy #0
  lda (palien),y
  bne MissileHit

  lda missilex		
  and #3
  clc
  adc #CHRMISSILE
  sta (palien),y	; Save updated missile
  rts

MissileHit:		; Missile has hit something
  cmp #CHRALIEN
  bcc MissileShelter
  cmp #CHRBASE
  bcs MissileRet	; Ignore bombs..
  jsr AlienHit		; Test for alien hit
  bcc MissileRet	; Not a hit, continue..
MissileEnd:		; Terminate missile
  ldx #0
  stx missilex
  rts

MissileShelter:		; Missile hits shelter
  tya
  sta (palien),y	; clr dest square
  beq MissileEnd


;--------------------------------------------------------------------------
;  BaseDraw - Service player base drawing
;--------------------------------------------------------------------------

BaseMove:
  lda basedir
  beq BaseDraw		; No movement? just redraw
  jsr BaseClr		; Clear current base on VDU
  lda basepos
  clc
  adc basedir
  cmp #2		; See if base is moving out of range..
  bcc BaseDraw
  cmp #BASEMAX
  bcs BaseDraw
  sta basepos		; Update base pos

BaseDraw:		; Draw player base
  lda basepos		; Convert 1/4 chr pos to chr index (y)
  lsr
  lsr
  tay
  lda basepos
  and #3
  asl 
  adc # CHRBASE
  sta BASEVDU,y
  iny
  adc #1
  sta BASEVDU,y
  cmp # CHRBASE+7
  bcc BaseExit
  iny
  adc #0
  sta BASEVDU,y
BaseExit:
  rts

BaseClr:		; Clr player base
  lda basepos		; Convert 1/4 chr pos to chr index (y)
  lsr
  lsr
  tay
  lda #0
  sta BASEVDU,y
  iny
  sta BASEVDU,y
  iny
  sta BASEVDU,y
  rts

  
CopySet:
  ldx #0		; Copy 64 chrs (512 bytes) of user chr data..
CopyLoop:
  lda ChrData,x
  sta ChrSet,x
  lda ChrData+$0100,x
  sta ChrSet+$0100,x
  ;txa; sta VDUP,x ;sta VDUP+256,x
  dex
  bne CopyLoop
  rts

DumpSet:
  ldx #0		; Copy & Display 256 chrset..
DumpLoop:
  txa
  sta VDUP,x 
  sta VDUP+256,x
  dex
  bne DumpLoop
  rts

KeyHit:
  ldx #0
  lda ZKEYDOWN		; Player key hit..
  cmp #KEYLEFT
  bne Key1 
  dex
Key1:
  cmp #KEYRIGHT
  bne Key2
  inx
  inc randseed
Key2:
  stx basedir		; Save ($ff,0,1) to player dir
  cmp #KEYQUIT
  beq KeyQuit		; Exit with carry set
  lda ZKEYSHIFT
  beq Key3
  jsr MissileFire	; Fire a missile
Key3:
  clc
KeyQuit:
  rts

DelaySec:
  ldx #100
DelayS1:
  jsr SyncFly
  dex
  bne DelayS1
  rts
    
;-----------	---------------------------------------------------------------
;  MainCode - Main Loop
;--------------------------------------------------------------------------

.if EXTRA

MainText:
.BYTE 156,147,"   F R E A X",13
.BYTE         "  -----------",13,13,31
.BYTE "(C) A.MILLETT 2014.",13,"A FREEWARE GAME.",13,13,30
.BYTE "CLEAR THE ALIENS!",13,13
.BYTE " LEFT,RIGHT - I,P",13
.BYTE " FIRE - CTRL",13
.BYTE " QUIT - X",13
.BYTE 13,13,13,158,"HIT SPACE TO START.",13
.BYTE 145,145,145,"SCORE:",0
MainText2:
.BYTE " HI:",0

PrintStr:	; Print null-term string at (Y;A)
  sta palien
  sty palien+1
PrintS1:
  ldy #0
  lda (palien),y
  beq PrintStrExit
  jsr KCHROUT
  inc palien
  bne PrintS1
  inc palien+1
  bne PrintS1
PrintStrExit:
  rts

.endif

MainCode:
  jsr ClrMem
  jsr CopySet		; Init chr set
MainNew:
  .if EXTRA
    jsr ModeNormal
    lda #<(MainText)		; Display Title Screen
    ldy #>(MainText)
    jsr PrintStr
    ldx score
    lda score+1
    cmp hiscore+1
    bcc FreaxT2
    bne FreaxT3
    cpx hiscore
    bcc FreaxT2
FreaxT3:
    stx hiscore
    sta hiscore+1
FreaxT2:
    jsr RPRINTINT
    lda #<(MainText2)
    ldy #>(MainText2)
    jsr PrintStr
    ldx hiscore
    lda hiscore+1
    jsr RPRINTINT
FreaxT1:
    jsr KGETIN
    cmp #88
    beq MainExit
    cmp #32
    bne FreaxT1
  .endif

  jsr ModeGfx
  jsr NewGame
MainLevelLoop:
  jsr DrawScreen
  jsr BaseDraw
MainLoop:  
  jsr KeyHit
  bcs MainGameOver
  jsr MissileMove
  lda naliens
  ora nbombs
  beq MainNextLevel		; No more aliens, level Over..
  jsr BombMove
  lda basehit
  bmi MainGameOver
  bne MainBaseHit
  jsr BaseMove		; Move/Redraw player base
  jsr AlienNext		; Animate next alien
  jsr AlienNext
  .if (VDUX > 30)
    jsr AlienNext
  .endif
  jsr SyncFly
  inc movephase		; Increment move phase
  jmp MainLoop

MainGameOver:
  jsr DelaySec
  jmp MainNew

MainBaseHit:		; Show base destruction 
 dec nlifes
 jsr OutStatus
 jsr BaseClr
 .if EXTRA
MainBH1:
   jsr SyncFly
   jsr BombMove		; Drop remaining bombs..
   inc movephase
   lda nbombs
   bne MainBH1
 .endif
 jsr DelaySec
 lda #0
 sta basehit
 lda nlifes
 bpl MainLoop
 bmi MainGameOver

MainExit:
  rts

MainNextLevel:
  jsr DelaySec
  inc level
  jsr NewLevel
  jmp MainLevelLoop

;--------------------------------------------------------------------------
;  ChrData - User defined chr bitmaps
;--------------------------------------------------------------------------

ChrData:
  .BYTE 0,0,0,0,0,0,0,0
  .BYTE $aa,$55,$aa,$55,$aa,$55,$aa,$55

  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %01000000
  .BYTE %10100010
  .BYTE %01010101
  .BYTE %10101010
  .BYTE %01010101
  ;.BYTE 0,0,0,0,$aa,$55,$aa,$55
  .BYTE 0,0,0,0,0,0,0,$ff

		; Alien phase 0 (CHR 4)
  .BYTE %00010000
  .BYTE %10011111
  .BYTE %10111111
  .BYTE %11101111
  .BYTE %01111001
  .BYTE %00111111
  .BYTE %00100000
  .BYTE %00100000
  
  .BYTE %10000000
  .BYTE %10000000
  .BYTE %11000000
  .BYTE %01100000
  .BYTE %11110000
  .BYTE %11010000
  .BYTE %01010000
  .BYTE %01000000

		; Alien phase 1
  .BYTE %00000100
  .BYTE %00000111
  .BYTE %00001111
  .BYTE %00011011
  .BYTE %00111110
  .BYTE %00101111
  .BYTE %00101000
  .BYTE %00000100
  
  .BYTE %00100000
  .BYTE %11100100
  .BYTE %11110100
  .BYTE %11011100
  .BYTE %01111000
  .BYTE %11110000
  .BYTE %00010000
  .BYTE %00100000

		; Alien phase 2
  .BYTE %00000001
  .BYTE %00001001
  .BYTE %00001011
  .BYTE %00001110
  .BYTE %00000111
  .BYTE %00000011
  .BYTE %00000010
  .BYTE %00000010
  
  .BYTE %00001000
  .BYTE %11111000
  .BYTE %11111100
  .BYTE %11110110
  .BYTE %10011111
  .BYTE %11111101
  .BYTE %00000101
  .BYTE %00000100

		; Alien phase 3 (3 chrs)
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000001
  .BYTE %00000011
  .BYTE %00000010
  .BYTE %00000010
  .BYTE %00000000
  
  .BYTE %01000010
  .BYTE %01111110
  .BYTE %11111111
  .BYTE %10111101
  .BYTE %11100111
  .BYTE %11111111
  .BYTE %10000001
  .BYTE %01000010

  .BYTE %00000000
  .BYTE %01000000
  .BYTE %01000000
  .BYTE %11000000
  .BYTE %10000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
		; Edge with adjacent alien
  .BYTE %00000000
  .BYTE %01000000
  .BYTE %01000000
  .BYTE %11000001
  .BYTE %10000011
  .BYTE %00000010
  .BYTE %00000010
  .BYTE %00000000

		; Player Base Phase 0 (4 phase) (CHR 14)
  .BYTE %00000100  
  .BYTE %00001110  
  .BYTE %01111111
  .BYTE %11111111
  .BYTE %11111111
  .BYTE %11111111
  .BYTE %11111111
  .BYTE %11000000

  .BYTE %00000000  
  .BYTE %00000000  
  .BYTE %11000000  
  .BYTE %11100000
  .BYTE %11100000
  .BYTE %11100000
  .BYTE %11100000
  .BYTE %01100000

		; Player Base Phase 1
  .BYTE %00000001  
  .BYTE %00000011
  .BYTE %00011111
  .BYTE %00111111
  .BYTE %00111111
  .BYTE %00111111
  .BYTE %00111111
  .BYTE %00110000

  .BYTE %00000000  
  .BYTE %10000000  
  .BYTE %11110000
  .BYTE %11111000
  .BYTE %11111000
  .BYTE %11111000
  .BYTE %11111000
  .BYTE %00011000

		; Player Base Phase 3
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000111
  .BYTE %00001111
  .BYTE %00001111
  .BYTE %00001111
  .BYTE %00001111
  .BYTE %00001100

  .BYTE %01000000
  .BYTE %11100000
  .BYTE %11111100
  .BYTE %11111110
  .BYTE %11111110
  .BYTE %11111110
  .BYTE %11111110
  .BYTE %00000110

		; Player Base Phase 3
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000001
  .BYTE %00000011
  .BYTE %00000011
  .BYTE %00000011
  .BYTE %00000011
  .BYTE %00000011

  .BYTE %00010000
  .BYTE %00111000
  .BYTE %11111111
  .BYTE %11111111
  .BYTE %11111111
  .BYTE %11111111
  .BYTE %11111111
  .BYTE %00000001

  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %10000000
  .BYTE %10000000
  .BYTE %10000000
  .BYTE %10000000
  .BYTE %10000000

		; Player Missile Pos 0 (4 pos) (CHR 23)
  .BYTE %01000000  
  .BYTE %01000000  
  .BYTE %01000000  
  .BYTE %01000000  
  .BYTE %01000000  
  .BYTE %01000000  
  .BYTE %01000000  
  .BYTE %01000000  

		; Missile Pos 1 
  .BYTE %00010000  
  .BYTE %00010000  
  .BYTE %00010000  
  .BYTE %00010000  
  .BYTE %00010000  
  .BYTE %00010000  
  .BYTE %00010000  
  .BYTE %00010000  
		; Missile Pos 2
  .BYTE %00000100  
  .BYTE %00000100  
  .BYTE %00000100  
  .BYTE %00000100  
  .BYTE %00000100  
  .BYTE %00000100  
  .BYTE %00000100  
  .BYTE %00000100  
		; Missile Pos 3
  .BYTE %00000001
  .BYTE %00000001
  .BYTE %00000001
  .BYTE %00000001
  .BYTE %00000001
  .BYTE %00000001
  .BYTE %00000001
  .BYTE %00000001

		; Alien Bomb pos 0 (CHR 27)
  .BYTE %00100100
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00000000
  .BYTE %00000000

		; Bomb pos 1
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00100100
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000

		; Bomb pos 2
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00100100
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000

  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000

		; Bomb pos 3
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00100100
  .BYTE %00011000

  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000
  .BYTE %00000000

		; Chrset numbers 0-9 (CHR 33)
  .BYTE %00111100
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %00111100
  .BYTE %00000000

  .BYTE %00011000
  .BYTE %00111000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00011000
  .BYTE %00111100
  .BYTE %00000000

  .BYTE %00111100
  .BYTE %01100110
  .BYTE %00000110
  .BYTE %00011100
  .BYTE %00110000
  .BYTE %01100000
  .BYTE %01111110
  .BYTE %00000000

  .BYTE %00111100
  .BYTE %01100110
  .BYTE %00000110
  .BYTE %00011100
  .BYTE %00000110
  .BYTE %01100110
  .BYTE %00111100
  .BYTE %00000000

  .BYTE %00000110
  .BYTE %00001110
  .BYTE %00011110
  .BYTE %00110110
  .BYTE %01100110
  .BYTE %01111111
  .BYTE %00000110
  .BYTE %00000000

  .BYTE %01111110
  .BYTE %01100000
  .BYTE %01111100
  .BYTE %00000110
  .BYTE %00000110
  .BYTE %01000110
  .BYTE %00111100
  .BYTE %00000000

  .BYTE %00111100
  .BYTE %01100110
  .BYTE %01100000
  .BYTE %01111100
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %00111100
  .BYTE %00000000

  .BYTE %01111110
  .BYTE %00000110
  .BYTE %00001100
  .BYTE %00011000
  .BYTE %00110000
  .BYTE %00110000
  .BYTE %00110000
  .BYTE %00000000

  .BYTE %00111100
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %00111100
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %00111100
  .BYTE %00000000

  .BYTE %00111100
  .BYTE %01100110
  .BYTE %01100110
  .BYTE %00111110
  .BYTE %00000110
  .BYTE %01100110
  .BYTE %00111100
  .BYTE %00000000


ChrEnd:
FreeMem:
